/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef IMPL_TYPE_HESAIPOINTCLOUD_H
#define IMPL_TYPE_HESAIPOINTCLOUD_H

#include "impl_type_driverheader.h"
#include "impl_type_hesaipoints.h"
#include "impl_type_boolean.h"

struct HesaiPointCloud {
    ::DriverHeader header;
    ::HesaiPoints points;
    ::Boolean isDense{ false };

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(header);
        fun(points);
        fun(isDense);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(header);
        fun(points);
        fun(isDense);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("header", header);
        fun("points", points);
        fun("isDense", isDense);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("header", header);
        fun("points", points);
        fun("isDense", isDense);
    }

    friend bool operator==(const ::HesaiPointCloud& lhs, const ::HesaiPointCloud& rhs) noexcept
    {
        return (lhs.header == rhs.header) && (lhs.points == rhs.points) && (lhs.isDense == rhs.isDense);
    }
};


#endif // IMPL_TYPE_HESAIPOINTCLOUD_H
